datablock itemData(DamageDisplay : printGun)
{
	image = "";
	uiName = "";
	shapeFile = "base/data/shapes/empty.dts";
};
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$DamagePopUp::Prefs)
	{
		if(!$RTB::RTBR_ServerControl_Hook)
			exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
		RTB_registerPref("Red Amount", "DamagePopUp", "$Pref::DamagePopUp::ColorR", "int 0 255", "Script_DamagePopUp", 255, 0, 0, "onChangeColorR");
		RTB_registerPref("Green Amount", "DamagePopUp", "$Pref::DamagePopUp::ColorG", "int 0 255", "Script_DamagePopUp", 255, 0, 0, "onChangeColorG");
		RTB_registerPref("Blue Amount", "DamagePopUp", "$Pref::DamagePopUp::ColorB", "int 0 255", "Script_DamagePopUp", 255, 0, 0, "onChangeColorB");
		RTB_registerPref("Color Scale", "DamagePopUp", "$Pref::DamagePopUp::ColorScale", "bool", "Script_DamagePopUp", 0, 0, 0);
		$DamagePopUp::Color = $Pref::DamagePopUp::ColorR SPC $Pref::DamagePopUp::ColorG SPC $Pref::DamagePopUp::ColorB;
		$DamagePopUp::Prefs = true;
		$Pref::DamagePopUp::TeamColor = false;
		if(isObject(Slayer))
			RTB_registerPref("Team Color Damage", "DamagePopUp", "$Pref::DamagePopUp::TeamColor", "bool", "Script_DamagePopUp", 0, 0, 0);
	}
}
function onChangeColorR(%old,%new)
{
	$DamagePopUp::Color = removeWord(0,$DamagePopUp::Color);
	$DamagePopUp::Color = %new SPC $DamagePopUp::Color;
}
function onChangeColorG(%old,%new)
{
	%Red = getWord(0,$DamagePopUp::Color);
	$DamagePopUp::Color = removeWord(1,$DamagePopUp::Color);
	$DamagePopUp::Color = %Red SPC %new SPC $DamagePopUp::Color;
}
function onChangeColorB(%old,%new)
{
	$DamagePopUp::Color = removeWord(2,$DamagePopUp::Color);
	$DamagePopUp::Color = $DamagePopUp::Color SPC %new;
}
package Popup
{
	function DamageDisplay::onPickup(%this, %obj, %col)
	{
		return;
	}
	function Armor::damage(%data, %this, %proj, %hitPos, %damage, %type)
	{
		%damagenot = new Item()
		{
			datablock = DamageDisplay;
			position = %hitPos;
			scale = "0.75 0.75 0.75";
		};
		%damagenot.setVelocity("0 0 5");
		%damagenot.setShapeName(mFloatLength(%damage,0));
		%damagenot.schedule(750,delete);
		if($Pref::DamagePopUp::ColorScale)
		{
			%colorpart = 1 - ((%damage/%data.maxDamage) * 2);
			if(%colorpart < 0)
				%colorpart = 0;
			%color = "1" SPC %colorpart SPC %colorpart;
		}
		else
		{
			if($Pref::DamagePopUp::TeamColor)
			{
				%client = %proj.client;
				if(isObject(%client) && %client.getClassName() $= "GameConnection")
				{
					%team = %client.getTeam();
					if(isObject(%client) && isObject(%team))
						%color = %team.colorRGB;
				}
				else
				{
					%color = $DamagePopUp::Color;
					%color = processColor(%color);
				}
			}
			else
			{
				%color = $DamagePopUp::Color;
				%color = processColor(%color);
			}
		}
		%damagenot.setShapeNameColor(%color);
		parent::damage(%data, %this, %proj, %hitPos, %damage, %type);
	}
	function processColor(%color)
	{
		%R = getWord(%color,0)/255;
		%G = getWord(%color,1)/255;
		%B = getWord(%color,2)/255;
		return %R SPC %G SPC %B;
	}
	function Vehicle::Damage(%this,%damagea,%pos,%damage,%type)
	{
		%damagenot = new Item()
		{
			datablock = DamageDisplay;
			position = %pos;
			scale = "0.75 0.75 0.75";
		};
		%damagenot.setVelocity("0 0 5");
		%damagenot.setShapeName(mFloatLength(%damage,0));
		%damagenot.schedule(750,delete);
		if($Pref::DamagePopUp::ColorScale)
		{
			%colorpart = 1 - ((%damage/%data.maxDamage) * 2);
			if(%colorpart < 0)
				%colorpart = 0;
			%color = "1" SPC %colorpart SPC %colorpart;
		}
		else
		{
			%color = $DamagePopUp::Color;
			%color = processColor(%color);
		}
		%damagenot.setShapeNameColor(%color);
		parent::damage(%this,%damage,%pos,%damage,%type);
	}
};
activatePackage(Popup);